#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

char **str_split (char *s, const char *ct)
{
   char **tab = NULL;

   if (s && ct)
   {
      int i;
      char *cs = NULL;
      size_t size = 1;

      for (i = 0; (cs = strtok(s, ct)); i++)
      {
         if (size <= i + 1)
         {
            void *tmp = NULL;

            size <<= 1;
            tmp = realloc(tab, sizeof (*tab) * size);
            if (tmp)
            {
               tab = tmp;
            }
            else
            {
               fprintf(stderr, "Not enough memory\n");
               free(tab);
               tab = NULL;
               exit(EXIT_FAILURE);
            }
         }
         tab[i] = cs;
         s = NULL;
      }
      tab[i] = NULL;
   }
   return tab;
}

double date_iso_to_jd (char *date_iso)
{
   signed int y;
   int m;
   double foo1, foo2, foo3, foo4, a, jj, jj1, jj2;
   double b = 0.0;
   double c = 0.0;

   /* recupere la date et l'heure */
   char **isodate;
   isodate = str_split(date_iso, "T");

   /* decompose la date */
   char **zdate;
   zdate = str_split(isodate[0], "-");
   int year= atoi(zdate[0]);
   int month = atoi(zdate[1]);
   int day = atoi(zdate[2]);

   /* decompose l'heure */
   char **ztime;
   ztime = str_split(isodate[1], ":");
   double hour = atof(ztime[0]) + atof(ztime[1])/60.0 + atof(ztime[2])/3600.0;

   /* calcul du jour julien */
   if (month > 2)
   {
      y = year;
      m = month;
   }

   if(month == 1 || month == 2)
   {
      y = year - 1;
      m = month + 12;
   }

   /* La date est dans le calendrier gregorien (ie. >= 15/10/1582) */
   if (!(year <= 1582 && month <= 10 && day < 15))
   {
      foo1 = modf(y / 100.0, &a);
      foo2 = modf(a / 4.0, &b);
      b = 2 - a + b;
   }

   /* cas des annees negatives */
   if (year < 0)
   {
      c = 0.75;
   }

   foo3 = modf(365.25 * y - c, &jj1);
   foo4 = modf(30.6001 * (m + 1), &jj2);

   jj = jj1 + jj2 + day + hour/24.0 + 1720994.5 + b;

   return jj;
}

