#include <stdio.h>

void usage_help(char *prgme, int topic)
{
  FILE *p_f = stdout;

  fprintf(p_f, "-------------------------------------------------------------------------------------\n");
  switch (topic)
  {
    case 0:
      fprintf(p_f, "- SkyBoTConeSearch client -\n");
      break;
    case 1:
      fprintf(p_f, "- SkyBoTResolver client -\n");
      break;
    case 2:
      fprintf(p_f, "- SkyBoTStatus client -\n");
      break;
    default:
      fprintf(p_f, "- Unknown SkyBoT client -\n");
  }
  fprintf(p_f, "-------------------------------------------------------------------------------------\n");
  fprintf(p_f, "Usage: %s [args] [options]\n",prgme);

  switch (topic)
  {
    case 0:
      fprintf(p_f, "Args:\n");
      fprintf(p_f, "   -d <value>, --date <value>      Gregorian date (UTC) of the requested epoch\n");
      fprintf(p_f, "                                   expressed in ISO format or Julian day\n");
      fprintf(p_f, "   -f <value>, --fov <value>       J2000 equatorial geocentric coordinates of the\n");
      fprintf(p_f, "                                   FOV center, in degrees (e.g. 15.1234+20.04432)\n");
      fprintf(p_f, "Options:\n");
      fprintf(p_f, "   -l <value>, --observer <value>  Observer's location code (e.g 500 or 007)\n");
      fprintf(p_f, "   -m <value>, --mime <value>      Mime type of the result: (text)|html|votable|json\n");
      fprintf(p_f, "   -o <value>, --output <value>    Kind of results: object|(basic)|all\n");
      fprintf(p_f, "   -r <value>, --radius <value>    Radius of the field of view, in arcsec (e.g. 900x900 or 1200)\n");
      break;

    case 1:
      fprintf(p_f, "Args:\n");
      fprintf(p_f, "   -d <value>, --date <value>      Gregorian date (UTC) of the requested epoch\n");
      fprintf(p_f, "                                   expressed in ISO format or Julian day\n");
      fprintf(p_f, "   -n <value>, --name <value>      Name or designation of the target\n");
      fprintf(p_f, "Options:\n");
      fprintf(p_f, "   -l <value>, --observer <value>  Observer's location code (e.g 500 or 007)\n");
      fprintf(p_f, "   -m <value>, --mime <value>      Mime type of the result: (text)|html|votable|json\n");
      fprintf(p_f, "   -o <value>, --output <value>    Kind of results: object|(basic)|all\n");
      break;

    case 2:
      fprintf(p_f, "Options:\n");
      fprintf(p_f, "   -d <value>, --date <value>      Gregorian date (UTC) of the requested epoch\n");
      fprintf(p_f, "                                   expressed in ISO format or Julian day\n");
      fprintf(p_f, "   -m <value>, --mime <value>      Mime type of the result: (text)|html|votable|json\n");
      fprintf(p_f, "   -p <value>, --project <value>   Name of the SkyBoT database: (sbot2)|sbotRosetta|sbotKepler|sbotEarthL2|sbotTESS\n");
      break;

    default:
      fprintf(p_f, "what?\n");
  }
  fprintf(p_f, "\n");
  fprintf(p_f, "(C) 2006-2020, IMCCE - J. Berthier & J. Normand\n");
}
